package service_test

import (
	"bytes"
	"crypto/rand"
	"crypto/rsa"
	"git.cijber.net/zer.ooo/service"
	"testing"
)

func TestSingleRound(t *testing.T) {
	keyA, _ := rsa.GenerateKey(rand.Reader, 4096)
	keyB, _ := rsa.GenerateKey(rand.Reader, 4096)
	signature := []byte("Hello world!")
	v := &service.BaseMessage{}
	x := make([]byte, 0)
	b := bytes.NewBuffer(x)
	err := service.EncryptAndSign(v, keyA, &keyB.PublicKey, signature, b)

	if err != nil {
		t.Errorf("Failed encrypting: %s", err)
	}

	err = service.DecryptAndVerify(b.Bytes(), keyB, &keyA.PublicKey, signature, &service.BaseMessage{})

	if err != nil {
		t.Errorf("Failed decrypting: %s", err)
	}
}
